/*
Document   :  Insane Import
Author     :  Andrei Dinca, AA-Team http://codecanyon.net/user/AA-Team
*/

// Initialization and events code for the app
MGInsaneMode = (function($) {
	"use strict";

	// public
	var debug_level = 0;
	var maincontainer = null;
	var background_loading_container = null;
	var loading = null;
	var async_images = [];
	var nb_of_request = 0;

	// init function, autoload
	(function init() {
		// load the triggers
		$(document).ready(function() {
			maincontainer = $("#MG_iw-section-content");
			loading = $(".MG_iw-loader");
			background_loading_container = maincontainer.find(".MG-insane-work-in-progress");
			triggers();
		});
	})();
	
	function create_products_scroll()
	{
		var container = $('.WZC-products-scroll-cointainer');
		container.width( $("div#MG-content-wrap").width() - 70 );
		
		container.find("ul").width( ( container.find("ul li").eq(0).outerWidth() + 30 ) * container.find("ul li").size() );
		container.css( 'overflow', 'auto' );
		
		$("#MG-no-products").hide();
		container.css( 'margin-bottom', '60px' );
	}
	
	function toggle_products_list( that )
	{
		var products_container = maincontainer.find(".WZC-products-scroll-cointainer");
		
		// need to open
		if( products_container.css('overflow') == 'auto' ){
			products_container.css('overflow', 'visible');
			products_container.find("ul").data("width", products_container.find("ul").width() );
			products_container.find("ul").width( "100%" );
			
			that.find("span").eq(0).hide();
			that.find("span").eq(1).show();
		}
		
		else{
			products_container.find("ul").width( products_container.find("ul").data("width") );
			products_container.css('overflow', 'auto');
			that.find("span").eq(1).hide();
			that.find("span").eq(0).show();
		}
		
		return;
	}
	
	function select_category()
	{
		var search_on 	= maincontainer.find("#MG-search-on"),
			def_search	= search_on.val(),
			custom 		= maincontainer.find("#MG-custom-browsenode"),
			dropdown 	= maincontainer.find("#MG-select-from-list");
		
		function set_search_on( val )
		{
			val = $.trim( val ); 
			if( val != "" ){
				search_on.val( val );
			}else{
				search_on.val( def_search );
			}
		}
		
		custom.on( 'keydown, keyup', function(){ set_search_on( $(this).val() ) });
		dropdown.on( 'change', function(){ set_search_on( $(this).val() ) });
	}

	function browse_node_lookup( that )
	{
		var val 			= that.val().split("|"),
			search_index 	= val[0],
			browse_node 	= val[1];

		loading.show();

		if( that.attr('name') == 'categs' ){
			maincontainer.find(".MG-form-sub-categs").html('');
		}

		var data = {
            'action'	: 'MG_ajax',
            'sub_action': 'BrowseNodeLookup',
			'params'	: {
				'search_index'	: search_index,
				'browse_node'	: browse_node
			}
       	};

       	$.post(ajaxurl, data, function (response) {
			
			if( response.status == 'valid'){
				maincontainer.find(".MG-form-sub-categs").append(response.html);
			}

			loading.hide();
			
        }, 'json');	

		console.log( data  );
	}
	
	function search_for_products( form )
	{
		loading.show();
		var data = {
            'action'	: 'MG_ajax',
            'sub_action': form.data('action'),
			'params'	: form.serialize()
       	};
       	
		$.post(ajaxurl, data, function (response) {
			
			if( response.status == 'invalid' ){
				$("#MG-queued-products-box").hide();
				$("#MG-search-logs-box").html( '<div class="MG_iw-status-error">' + ( response.msg ) + '</div>' );
			}else{

				$("#WZC-selected-product").html( response.html );

				count_queued_products();
				
				$("#MG-queued-products-box").show();
			}

			loading.hide();
			
        }, 'json');	
	}
	
	function background_loading( msg, status )
	{
		if( status != 'show' ) {
			background_loading_container.hide();
		}
		
		background_loading_container.find('span').text( msg );
		background_loading_container.show();
		background_loading_container.animate({
			'height': '90px'
		}, 350 );
	}
	
	function count_queued_products()
	{
		var container 	= $("#MG-queued-products"),
			products 	= $("#WZC-selected-product");
		
		$("#MG-total-products").text( products.find("input").size() );
		$("#MG-selected-products").text( products.find("input:checked").size() );
	}
	
	
	function toggle_selected_products( that )
	{
		that = that.parent("li");
		var input = that.find("input"),
			input_container = that.find(".MG-checked-product");
		input.prop('checked', !(input.is(':checked'))); 
		
		if( input_container.hasClass("MG-selected") ){
			input_container.removeClass("MG-selected");
			input_container.addClass("MG-not-selected");
		}else{
			input_container.addClass("MG-selected");
			input_container.removeClass("MG-not-selected");
		}
		
		count_queued_products();
	}
	
	function count_images_left()
	{
		$("#MG-images-nb").text( $(".MG-images-imported").find("a").size() );
	}

	function download_async_images( images, callback )
	{
		var action_done = 0,
			nb_chunk = 5;

		count_images_left();

		// go to the next movie import
		if( images.find('a').size() == 0 ){
			if( typeof callback == 'function' ){
				callback();
			}
		}
		images.find('a').slice(0, nb_chunk).each(function(){
			var first_img = $(this);
			if( first_img.size() > 0 ){
				first_img.find('ul').show();
				var data = {
		            'action'	: 'MG_ajax',
		            'sub_action': 'import-image',
					'post_id'	: first_img.data('postid'),
					'where'		: first_img.data('where'),
					'full'		: first_img.data('full'),
					'term_id'	: first_img.data('termid'),
					'nb_request': nb_of_request
		       	};
		       	
		       	$.post(ajaxurl, data, function (response) {

		       		nb_of_request++;

					action_done++;
					first_img.remove();
					count_images_left();

					if( nb_chunk == action_done ){
						download_async_images( images, callback );
						return;
					}

					else if( images.find('a').size() == 0 ){
						download_async_images( images, callback );
						return;
					}

				}, 'json');
			}
		});
		
	}
	function import_all( that )
	{
		var lightbox 		= maincontainer.find("#MG-lightbox-import-wrapper"),
			progress_bar 	= lightbox.find(".MG-progress-bar"),
			imported		= lightbox.find(".MG-products-imported"),
			tails			= lightbox.find(".MG-products-queued"),
			images			= lightbox.find(".MG-images-imported"),
			products 		= maincontainer.find("#WZC-selected-product input:checked"),
			nb_products 	= products.size();
		
		
		if( nb_products == 0 ){
			alert("Please Select some products!");
			return;
		}
		
		tails.prev('h2').find('span')
			.text( "(" + nb_products + ")" )
			.data('nb', nb_products);
		 	
		var selected_products = [];
		$.each( products, function(){

			var prod 			= $(this),
				asin 			= prod.parents('li').eq(0).data('asin'),
				title 			= prod.parents('li').eq(0).data('title'),
				salesrank 		= prod.parents('li').eq(0).data('salesrank'),
				binding 		= prod.parents('li').eq(0).data('binding'),
				brand 			= prod.parents('li').eq(0).data('brand'),
				smallimage 		= prod.parents('li').eq(0).data('smallimage'),
				mediumimage 	= prod.parents('li').eq(0).data('mediumimage'),
				largeimage 		= prod.parents('li').eq(0).data('largeimage');

			tails.append( '<a id="MG-prod-' + ( asin ) + '" data-asin="' + ( asin ) + '" data-largeimage="' + ( largeimage ) + '" data-mediumimage="' + ( mediumimage ) + '" data-smallimage="' + ( smallimage ) + '" data-brand="' + ( brand ) + '" data-binding="' + ( binding ) + '"   data-title="' + ( title ) + '" data-salesrank="' + ( salesrank ) + '" target="_blank" href="#"><ul class="MG-preloader"><li></li><li></li><li></li><li></li><li></li></ul><img src="' + ( smallimage ) + '" /></a>' );
			
			selected_products.push(asin);
		});

		lightbox.show();
		
		var cc = 1;
		function import_product() {
			
			var prod = selected_products[cc-1],
				prod_elm = $( "#MG-prod-" + prod );

			prod_elm.find("ul").show();

			var data = {
	            'action'	: 'MG_ajax',
	            'sub_action': 'import-product',
				'product'	: {
					'asin': prod_elm.data('asin'),
					'title': prod_elm.data('title'),
					'salesrank': prod_elm.data('salesrank'),
					'binding': prod_elm.data('binding'),
					'brand': prod_elm.data('brand'),
					'smallimage': prod_elm.data('smallimage'),
					'mediumimage': prod_elm.data('mediumimage'),
					'largeimage': prod_elm.data('largeimage')
				}
	       	};

	       	if( typeof(data.product.asin) == 'undefined' ){

	       		$("#MG-imported-nb").data('nb', 0);
	       		lightbox.hide();
	       		return;
	       	}
	       	
			$.post(ajaxurl, data, function (response) {
				
				if( response.status == 'valid' ){
					$.each( response.asyn_images, function(key, val){
						images.append( '<a data-termid="' + ( val.term_id ) + '" data-full="' + ( val.full ) + '" data-where="' + ( val.where ) + '" data-postid="' + ( response.post_id ) + '" target="_blank" href="' + ( val.full ) + '"><ul class="MG-preloader"><li></li><li></li><li></li><li></li><li></li></ul><img src="' + ( val.thumb ) + '" height="70" /></a>' ); 
					});
				}

				count_images_left();
				
				var proc = cc * 100 / nb_products;  
				var span = $(".MG-progress-bar span");
				
				span.width( proc + "%" );
				span.find('em').text( Math.round( proc ) + "%" )
				
				if( response.status == 'valid' || response.status == 'product_duplicate' ){
					imported.prepend( prod_elm );
					
					var q_nb = $("#MG-queued-nb"),
						q_nb_size = parseInt(q_nb.data('nb')),
						q_nb_new_size = q_nb_size - 1;
					
					q_nb.data('nb', q_nb_new_size);
					q_nb.text( '(' + ( q_nb_new_size ) + ')' );
					
					
					var i_nb = $("#MG-imported-nb"),
						i_nb_size = parseInt(i_nb.data('nb')),
						i_nb_new_size = i_nb_size + 1;
					
					i_nb.data('nb', i_nb_new_size);
					i_nb.text( '(' + ( i_nb_new_size ) + ')' );
					
					prod_elm.find("ul").hide();
					
					cc++;
					
					download_async_images( images, function(){
						import_product();
					} );
				}
	        }, 'json');
		}
		
		import_product();
	}

	function search_in_ajax( that )
	{
		var selected = that.find(".MG-search-in_ajax-selected"),
			suggestions = that.find(".MG-search-in_ajax-suggestions");


		function build_with_keywords()
		{
			var input = that.find("input.with_keywords"),
				the_val = [];

			selected.find("a").each(function(){
				var that3 = $(this),
					id = that3.attr('href').replace("#", "");

				the_val.push( id );
			});

			input.val( the_val.join("|") );
		}

		suggestions.on("click", "a", function(){
			var that2 = $(this);

			selected.append( '<a href="' + ( that2.attr('href') ) + '">' + ( that2.text() ) + '</a>' );
			suggestions.hide();
			build_with_keywords();
		});

		selected.on("click", "a", function(){
			$(this).remove();
			build_with_keywords();
		});

		that.find("input.parameter").keypress(function(){
			var that2 = $(this),
				val = that2.val();

			if( val != "" ){
				var data = {
		            'action'	: 'MG_ajax',
		            'sub_action': 'keyword-search',
					'term'		: val
		       	};
				$.post(ajaxurl, data, function (response) {
					if( response.html != "" ){
						suggestions.html( response.html );
						suggestions.show();
					}else{
						suggestions.hide();
					}
				}, 'json');
			}else{
				suggestions.hide();
			}
		});
	}
	
	function triggers()
	{
		select_category();
		
		maincontainer.on('click', "#WZC-selected-product li .MG-checked-product", function(e){
			e.preventDefault();
			
			toggle_selected_products( $(this) );
		});
		
		maincontainer.on('change', "#we-select-all", function(e){
			var cont = $(this).parent("label");
			cont.find("span").hide();
			if( $(this).is(":checked") == true ){
				$("#WZC-selected-product li .MG-checked-product input:not(:checked)").each(function(){
					toggle_selected_products( $(this).parent(".MG-checked-product") );
				});
				cont.find("span.we-uncheck-all").show();
			}else{
				$("#WZC-selected-product li .MG-checked-product input:checked").each(function(){
					toggle_selected_products( $(this).parent(".MG-checked-product") );
				});
				cont.find("span.we-check-all").show();
			}
		});

		maincontainer.on('change', ".parameter[name='categs'], .parameter[name='sub-categs']", function(){
			browse_node_lookup( $(this) );
		});
		
		maincontainer.on('submit', ".MG-grab-products", function(e){
			e.preventDefault();
			search_for_products( $(this) ); 
		});

		// debug
		//search_for_products( $(".MG-grab-products") ); 
		
		maincontainer.on('click', "#MG-import-all", function(e){
			e.preventDefault();
			
			import_all( $(this) );
		});
		
		maincontainer.on('click', ".MG-tmdb-sites-selected a", function(e){
			e.preventDefault();
		});
		
		maincontainer.on('click', ".MG-tmdb-sites a", function(e){
			e.preventDefault();
			
			var clone = $(this).clone();
			maincontainer.find(".MG-tmdb-sites-selected").html( clone );
			maincontainer.find(".MG-tmdb-sites-container input").val( clone.attr("href").replace("#", "" ) );
		});
		
		maincontainer.on('change', "#test-speedometer", function(){
			change_speedometer_value( $(this).val() );
		});

		search_in_ajax( $(".MG-search-in_ajax") );
		
		maincontainer.find(".MG-insane-tabs").each(function(){
			var that = $(this),
				btns = that.find(".MG-insane-panel-headline a"),
				tabs = that.find(".MG-insane-tab-content");
			
			that.on('click', '.MG-insane-panel-headline a', function(e){
				e.preventDefault();
				
				var btn = $(this),
					rel = $( btn.attr("href") );

				if( btn.hasClass('on') ) return;
				
				tabs.hide();
				rel.fadeIn( 200 );

				btns.parent("div").find("a.on").removeClass("on");
				btn.addClass("on");
			});
			
			//!! tmp
			//$(".MG-insane-panel-headline a").eq(2).click();
		});
	}

	// external usage
	return {
		"background_loading": background_loading
		//"asin_grabber": asin_grabber
	}
})(jQuery);

