<?php
 /**
 * About module
 * http://www.aa-team.com
 * ======================
 *
 * @package		MG_
 * @author		Andrei Dinca, AA-Team
 * @version		1.0
 */
! defined( 'ABSPATH' ) and exit;

if(class_exists('MG_Search') != true) {
	class MG_Search {
		
		const VERSION = '1.0';
		
		/**
		 * parent storage
		 *
		 * @var array
		 */
		public $parent = array();
		
		private $action = '';
		private $wp_import = null;

		public $aaAmazonWS = null;
        public $amz_settings = array();
		
		/**
		 * The constructor
		 */
		public function __construct( $parent=array() )
		{
			// load parent
			$this->parent = $parent;
			add_action( "toplevel_page_MG", array( $this, 'extra_head' ) );

			// load the amazon webservices client class
			require_once MG()->path( 'HELPERS_DIR', 'amazon.class.php' );

			$amz_setup = array(
				'AccessKeyID' => (isset(MG()->settings['AccessKeyID']) ? MG()->settings['AccessKeyID'] : 'AKIAJVUERCW2YISPWH2A'),
				'SecretAccessKey' => isset(MG()->settings['SecretAccessKey']) ? MG()->settings['SecretAccessKey'] : 'pF1OIAz2Ojk6qWUwdOXu3INO87/2tfMYLao6RqwP',
				'AffiliateId' => isset(MG()->settings['AffiliateId']) ? MG()->settings['AffiliateId'] : 'your-aff-id',
				'country' => isset(MG()->settings['country']) ? MG()->settings['country'] : 'com'
			);

			// create new amazon instance
			$this->aaAmazonWS = new aaAmazonWS( $amz_setup['AccessKeyID'], $amz_setup['SecretAccessKey'], $amz_setup['country'] , $amz_setup['AffiliateId'] );

			$this->aaAmazonWS->load_csv_categs();
        }
		
		public function extra_head()
		{
			if( "search" == MG_action() ){
				wp_enqueue_script( 'MG-auto-find', MG()->includeUrl( 'search/app.class.js' ), array(), self::VERSION );
				wp_enqueue_style( 'MG-auto-find', MG()->includeUrl( 'search/styles.css' ), array(), self::VERSION );
			}
		}
		
		public function print_interface()
		{
			$html = array();
			ob_start();

			if( isset($_GET['import']) ){
				global $wpdb;

				//$last_row = $wpdb->get_row( "SELECT * FROM wp_genres WHERE 1=1 order by id desc limit 1", ARRAY_A );
				$start = MG()->wp_filesystem->get_contents( MG()->path( 'SEARCH_DIR', 'lastid.txt' ) );
				$chunk = 1000;

				for ($i = $start; ($i <= $start + $chunk); ++$i) {
					
				   	$words = wp_remote_get( 'http://api.themoviedb.org/3/keyword/' . ( $i ) . '?api_key=a4dfc560f6c60cb3d297170e6c9e43c6' );
					$word = json_decode( $words['body'], true );

					if( isset($word['status_code']) && $word['status_code'] == '25' ){
						sleep( 2 );
					}

					if( isset($word['id']) ){
						$wpdb->insert( 
							$wpdb->prefix . 'movie_keywords', 
							array( 
								'id' => $word['id'], 
								'name' => $word['name']
							), 
							array( 
								'%d', 
								'%s' 
							) 
						);
					}

					var_dump('<pre>', "<strong>" . $i . "</strong>: " . $words['body'] ,'</pre>'); 

					MG()->wp_filesystem->put_contents( MG()->path( 'SEARCH_DIR', 'lastid.txt' ), $i );
				}

			}
			if( isset($_GET['export']) ){
				global $wpdb;

				$results = $wpdb->get_results( "SELECT * FROM `" . ( $wpdb->prefix . 'movie_keywords' ) . "` WHERE 1=1", ARRAY_A );
			}
			?>
			<div class="MG-container clearfix" id="MG_iw-section-content" style="position: relative; margin-top: 60px;">
				
				<div id="MG-lightbox-import-wrapper">
					<div id="MG-lightbox-import-container">
						<div class="MG-progress-bar"><span style="width: 0%"><em>0%</em></span></div>
						
						<h2><span id="MG-queued-nb" data-nb="0">(0)</span> <?php _e('Queued Products', 'MG');?></h2>
						<div class="MG-products-queued"></div>
						
						<h2><span id="MG-imported-nb" data-nb="0">(0)</span> <?php _e('Imported Products', 'MG');?></h2>
						<div class="MG-products-imported"></div>
						
						<h2><span id="MG-images-nb" data-nb="0">(0)</span> <?php _e('Images Downloading', 'MG');?></h2>
						<div class="MG-images-imported"></div>
					</div>
				</div>
				
				<!-- Main Content Wrapper -->
				<div id="MG-content-wrap" class="clearfix">
					<div class="MG-insane-work-in-progress">
						<ul class="MG-preloader"><li></li><li></li><li></li><li></li><li></li></ul>
						<span class="MG-the-action">Execution action ...</span>
					</div>
					<!-- Content Area -->
					<div class="MG-insane-container MG-insane-tabs">
						<div class="MG-insane-panel-headline">
            				<a href="#MG-content-discover" class="on"><?php _e('Discover', 'MG');?></a>
            				<a href="#MG-single-item"><?php _e('Look Up Single Product', 'MG');?></a>
						</div>
						<div class="MG-insane-tabs-content">
							<div id="MG-content-scroll">
								<div id="MG-content-discover" class="MG-insane-tab-content">
		            				<form class="MG-grab-products" data-action="ItemSearch">
		            					<h4>The Search operation searches for items on Amazon. The Product Advertising API returns up to ten items per search results page.</h4>

										<label>
											<span>Keywords:</span>	
											<input class="parameter" name="keywords" placeholder="" value="" style="width: 60%" type="text">
											<span class='MG-form-note'>A word or phrase that describes an item, including author, artist, description, manufacturer, title, and so on.</span>
										</label>	

		            					<label>
											<span>Category:</span>
											<select class="parameter" name="categs" style="width: 200px">
												<?php 
												if( $this->aaAmazonWS->categs && count($this->aaAmazonWS->categs) > 0 ){
													foreach ($this->aaAmazonWS->categs as $key => $value) {
														//alpha2
														echo '<option value="' . ( $value['SearchIndex'] ) . '|' . ( $value['node'] ) . '">' . ( $value['department'] ) . '</option>';
													}
												}
												?>
											</select>
											<div class='MG-form-sub-categs'></div>
										</label>			
										
										<input type="submit" class="MG-button yellow " id="MG-search-for-products" value="Search for Products">
		            				</form>
		            			</div>
		            			<div id="MG-content-search" class="MG-insane-tab-content">
		            				<form class="MG-grab-products" data-action="search-files">
		            					<h4>Search for Products by title.</h4>
										<label>
											<span>term:</span>	
											<input class="parameter" minlength="0" name="term" placeholder="" value="" type="text">
											<span class='MG-form-note'>The string to search for</span>
										</label>
										
										<input type="submit" class="MG-button yellow " id="MG-search-for-products" value="Search for Products">
		            				</form>
		            			</div>
		            			<div id="MG-single-item" class="MG-insane-tab-content">
		            				
		            				<form class="MG-grab-products" data-action="search-by-item-id">
		            					<h4>Get the basic movie for a specific movie id. You can find the movie id from:<br/><br/><a href="https://www.themoviedb.org/">https://www.themoviedb.org/</a><br/><br/>
											<img src="<?php echo MG_asset_url( 'images/movieid.png' );  ?>">
		            					</h4>
		            					<label>
		            						<span>Item ID:</span>
											<input style="width: 200px;" type="text" placeholder="Paste the item id" name="itemid" value="">
											<span class="MG-form-note">The numeric ID of the item to return</span>
		            					</label>
		            					
		            					<input type="submit" value="Fetch Movie" id="MG-grabb-button" class="MG-button yellow ">
		            					
		            					<div class="MG-log-notice" style="display: none;">
		            						<i class="fa fa-info"></i>
		        							<p><?php _e('Returns the popular files for selected site.', 'MG');?></p>
		        						</div>
		            				</form>
		            			</div>
		            		</div>
	            		</div>
					</div>
					<div class="MG-insane-container MG-insane-tabs" id="MG-queued-products-box" style="margin-top: 90px">
                		<div class="MG-insane-panel-headline">
                			<a href="#MG-queued-products" class="on">
                				<span><i class="fa fa-th"></i></span>
                				<?php _e('Queued Products', 'MG');?>
                			</a>
						</div>
						<div class="MG-insane-tabs-content">
	            			<div id="MG-queued-products" class="MG-insane-tab-content">
	            				<div class="WZC-products-scroll-cointainer">
		            				<ul class="WZC-keyword-attached MG-insane-bigscroll" id="WZC-selected-product"></ul>
								</div>
								
								<div id="MG-no-products" class="MG-log-notice">
            						<i class="fa fa-info"></i>
        							<p><?php _e('No products selected yet. Please use tab above to add products to the list', 'MG');?></p>
        						</div>
	            			</div>
	            			<div class="MG-insane-tab-product-search-results-stats">
								<label class="MG-stats-block">
									Found:
									<span><span id="MG-total-products">0</span> products</span>
								</label>
								<label class="MG-stats-block">
									Selected for Import:
									<span><span id="MG-selected-products">0</span> products</span>
								</label>
								
								<a href="#" id="MG-import-all">
									<span><i class="fa fa-play"></i> <?php _e('Start Import', 'MG');?></span>
								</a>
								
								<label class="MG-select-deselect-all">
									<input type="checkbox" checked="true" id="we-select-all" />
									<span class="we-check-all">Check All</span>
									<span class="we-uncheck-all">Uncheck All</span>
								</label>
							</div>
	            		</div>
					</div>

					<div id="MG-search-logs-box"></div>
				</div>
			</div>
			<?php 
			$content = ob_get_contents();
			ob_clean();
			
			return $content;
		}
	}
}